import { VueConstructor } from "vue";
import { IPlugin, IEditor } from "../../baklavajs-core/types";
import { SequentialHook } from "../../baklavajs-core/src/events";
import { IViewPlugin } from "../types";
import NodeView from "./components/node/Node.vue";
import NodeOptionView from "./components/node/NodeOption.vue";
import NodeInterfaceView from "./components/node/NodeInterface.vue";
import ConnectionView from "./components/connection/ConnectionView.vue";
import ConnectionWrapper from "./components/connection/ConnectionWrapper.vue";
import TempConnectionView from "./components/connection/TemporaryConnection.vue";
import ContextMenu from "./components/ContextMenu.vue";
import Sidebar from "./components/Sidebar.vue";
export declare class ViewPlugin implements IPlugin, IViewPlugin {
    type: string;
    editor: IEditor;
    panning: {
        x: number;
        y: number;
    };
    scaling: number;
    sidebar: {
        visible: boolean;
        nodeId: string;
        optionName: string;
    };
    options: Record<string, VueConstructor>;
    hooks: {
        renderNode: SequentialHook<NodeView>;
        renderOption: SequentialHook<NodeOptionView>;
        renderInterface: SequentialHook<NodeInterfaceView>;
        renderConnection: SequentialHook<ConnectionView>;
    };
    components: {
        node: typeof NodeView;
        nodeOption: typeof NodeOptionView;
        nodeInterface: typeof NodeInterfaceView;
        connection: typeof ConnectionWrapper;
        tempConnection: typeof TempConnectionView;
        contextMenu: typeof ContextMenu;
        sidebar: typeof Sidebar;
    };
    register(editor: IEditor): void;
    registerOption(name: string, component: VueConstructor): void;
}
